import Graphics.UI.GLUT


makeVertex shape points =  renderPrimitive shape $ do 
                                mapM_ addColor points
                            where
                                addColor (x,y,z,c) = do
                                    color c 
                                    vertex $ Vertex3 x y z

makePoints :: [(GLfloat,GLfloat)] -> [(GLfloat,GLfloat,GLfloat,Color3 GLfloat)]
makePoints lst = [(fst(x),snd(x),0,(Color3 (abs (fst x)) (abs (snd x)) (calc (fst x) (snd x)))) | x <- lst]

makePoints' :: [(GLfloat,GLfloat)] -> [(GLfloat,GLfloat,GLfloat,Color3 GLfloat)]
makePoints' lst = [(fst(x),snd(x),0,(Color3 0.76 0.23 (calc 0.76 0.23))) | x <- lst]

makePoints'':: [(GLfloat,GLfloat)] -> [(GLfloat,GLfloat,GLfloat,Color3 GLfloat)]
makePoints'' lst = [(fst(x),snd(x),0,(Color3 0.56 0.34 (calc 0.56 0.34))) | x <- lst]

calc :: GLfloat -> GLfloat -> GLfloat
calc x y = sqrt(abs((x+y)/2))


facePoints :: [(GLfloat,GLfloat)]
facePoints = [(-0.15,0.66),
            (-0.27,0.54),
            (-0.49,0.46),
            (-0.52,0.31),
            (-0.47,0.21),
            (-0.53,0.09),
            (-0.50,-0.05),
            (-0.07,-0.56),
            (0.14,-0.50),
            (0.18,-0.33),
            (0.24,-0.25),
            (0.30,-0.08),
            (0.29,-0.03),
            (0.28,0.05),
            (0.26,0.11),
            (0.25,0.25),
            (0.15,0.47),
            (0.06,0.60)]
hairPoints :: [(GLfloat,GLfloat)]
hairPoints = [(0.22,0.32),
            (0.23,0.49),
            (0.00,0.83),
            (-0.41,0.89),
            (-0.61,0.77),
            (-0.92,0.32),
            (-0.92,0.02),
            (-0.83,-0.26),
            (-0.71,-0.41),
            (-0.64,-0.42)]

neckPoints :: [(GLfloat,GLfloat)]
neckPoints = [(-0.66,-0.29),
            (-0.64,-0.42),
            (-0.53,-0.63),
            (-0.16,-0.83),
            (-0.10,-0.82),
            (0.01,-0.70)]

beardPoints :: [(GLfloat,GLfloat)]
beardPoints = [(-0.60,-0.29),
                (-0.46,-0.45),
                (-0.12,-0.71),
                (0.10,-0.69),
                (0.21,-0.60),
                (0.22,-0.51),
                (0.32,-0.12),
                (0.30,-0.08)]

earPoints :: [(GLfloat,GLfloat)]
earPoints = [(-0.65,0.05),
            (-0.77,0.09),
            (-0.82,0.07),
            (-0.84,0.01),
            (-0.76,-0.23),
            (-0.69,-0.29),
            (-0.60,-0.29)]

insideEarPoints :: [(GLfloat,GLfloat)]
insideEarPoints = [(-0.62,-0.19),
                    (-0.65,-0.13),
                    (-0.69,0.03),
                    (-0.75,0.06),
                    (-0.82,0.02),
                    (-0.80,-0.10)]

nosePoints :: [(GLfloat,GLfloat)]
nosePoints = [(-0.05,-0.03),
            (-0.11,-0.10),
            (-0.10,-0.14),
            (-0.08,-0.15),
            (0.02,-0.15),
            (0.04,-0.16),
            (0.11,-0.16),
            (0.15,-0.09),
            (0.03,0.16)]

moustachePoints :: [(GLfloat,GLfloat)]
moustachePoints = [(-0.02,-0.15),
                    (-0.05,-0.19),
                    (-0.24,-0.24),
                    (-0.24,-0.27),
                    (0.05,-0.28),
                    (0.13,-0.24),
                    (0.21,-0.23),
                    (0.22,-0.19),
                    (0.12,-0.14),
                    (0.11,-0.16),
                    (0.05,-0.16),
                    (0.02,-0.15)]

mousePoints :: [(GLfloat,GLfloat)]
mousePoints = [(-0.19,-0.30),
                (-0.09,-0.28),
                (0.05,-0.28),
                (0.13,-0.24),
                (0.11,-0.35),
                (0.05,-0.39),
                (-0.10,-0.39)]

lipPoints :: [(GLfloat,GLfloat)]
lipPoints = [(-0.20,-0.30),
            (-0.12,-0.33),
            (0.03,-0.34),
            (0.11,-0.30),
            (0.12,-0.25)]

leftEyebrowPoints :: [(GLfloat,GLfloat)]
leftEyebrowPoints = [(-0.08,0.18),
                    (-0.14,0.21),
                    (-0.38,0.11),
                    (-0.27,0.12),
                    (-0.16,0.16),
                    (-0.10,0.15)]

rightEyebrowPoints :: [(GLfloat,GLfloat)]
rightEyebrowPoints = [(0.05,0.12),
                    (0.15,0.19),
                    (0.25,0.21),
                    (0.23,0.24),
                    (0.14,0.23),
                    (0.03,0.16)]

leftEyePoints :: [(GLfloat,GLfloat)]
leftEyePoints = [(-0.16,0.13),
                (-0.10,0.11),
                (-0.13,0.09),
                (-0.31,0.07)]

rightEyePoints :: [(GLfloat,GLfloat)]
rightEyePoints = [(0.13,0.17),
                (0.20,0.16),
                (0.22,0.14),
                (0.17,0.12),
                (0.07,0.13)]

rightPupilPoints :: [(GLfloat,GLfloat)]
rightPupilPoints = [(-0.25,0.09),
                    (-0.24,0.08),
                    (-0.19,0.08),
                    (-0.19,0.12),
                    (-0.13,0.09)]

leftPupilPoints :: [(GLfloat,GLfloat)]
leftPupilPoints = [(0.11,0.15),
                    (0.11,0.13),
                    (0.16,0.12),
                    (0.17,0.14),
                    (0.16,0.17)]

teethPoints :: [(GLfloat,GLfloat)]
teethPoints = [(-0.14,-0.32),
                (0.05,-0.32),
                (0.11,-0.29)]

teethPoints' :: [(GLfloat,GLfloat)]
teethPoints' = [(-0.14,-0.29),
                (-0.14,-0.32),
                (-0.09,-0.28),
                (-0.09,-0.32),
                (-0.04,-0.28),
                (-0.04,-0.32),
                (0.01,-0.28),
                (0.01,-0.32),
                (0.05,-0.28),
                (0.05,-0.32),
                (0.08,-0.27),
                (0.08,-0.31),
                (0.10,-0.26),
                (0.09,-0.30)]

h :: [(GLfloat,GLfloat)]
h = [(0.38,0.26),
    (0.38,0.16),
    (0.38,0.21),
    (0.45,0.22),
    (0.44,0.26),
    (0.45,0.16)]

a :: [(GLfloat,GLfloat)]
a = [(0.48,0.23),
    (0.52,0.23),
    (0.53,0.16),
    (0.48,0.16),
    (0.48,0.20),
    (0.53,0.20)]

s :: [(GLfloat,GLfloat)]
s = [(0.60,0.23),
    (0.56,0.23),
    (0.56,0.20),
    (0.60,0.19),
    (0.60,0.16),
    (0.56,0.16)]

k :: [(GLfloat,GLfloat)]
k = [(0.63,0.26),
    (0.63,0.16),
    (0.67,0.23),
    (0.63,0.19),
    (0.65,0.21),
    (0.68,0.16)]

e :: [(GLfloat,GLfloat)]
e = [(0.70,0.20),
    (0.76,0.20),
    (0.75,0.23),
    (0.70,0.23),
    (0.71,0.16),
    (0.76,0.16),
    (0.76,0.18)]

ll :: [(GLfloat,GLfloat)]
ll = [(0.78,0.26),
    (0.78,0.16),
    (0.82,0.26),
    (0.81,0.16)]

dot :: [(GLfloat,GLfloat)]
dot = [(0.88,0.26),
    (0.89,0.26),
    (0.88,0.25),
    (0.89,0.25)]

i :: [(GLfloat,GLfloat)]
i = [(0.89,0.23),
    (0.89,0.16)]

s' :: [(GLfloat,GLfloat)]
s' = [(0.96,0.22),
    (0.92,0.23),
    (0.92,0.20),
    (0.96,0.20),
    (0.96,0.16),
    (0.92,0.16)]

upperF :: [(GLfloat,GLfloat)]
upperF = [(0.55,0.09),
        (0.49,0.09),
        (0.55,0.04),
        (0.50,0.04),
        (0.49,0.09),
        (0.50,-0.01)]

upperU :: [(GLfloat,GLfloat)]
upperU = [(0.58,0.09),
        (0.58,-0.00),
        (0.65,0.00),
        (0.65,0.09)]

upperN :: [(GLfloat,GLfloat)]
upperN = [(0.69,-0.01),
        (0.68,0.09),
        (0.75,-0.01),
        (0.75,0.09)]

exclamationMark :: [(GLfloat,GLfloat)]
exclamationMark = [(0.79,0.09),
                    (0.79,0.02)]

dot' :: [(GLfloat,GLfloat)]
dot' = [(0.78,0.01),
        (0.78,-0.01),
        (0.80,-0.01),
        (0.80,0.00)]

exclamationMark' :: [(GLfloat,GLfloat)]
exclamationMark' = [(0.82,0.09),
                    (0.83,0.02)]

dot'' :: [(GLfloat,GLfloat)]
dot'' = [(0.82,0.01),
        (0.82,-0.01),
        (0.83,-0.01),
        (0.83,0.00)]

main :: IO()
main = do 
    (progName,_) <- getArgsAndInitialize
    createWindow progName
    windowSize $= Size 1000 1000
    displayCallback $= display
    mainLoop

display = do 
    clear [ColorBuffer]
    makeVertex LineLoop (makePoints facePoints)
    makeVertex LineStrip (makePoints hairPoints)
    makeVertex LineStrip (makePoints neckPoints)
    makeVertex LineStrip (makePoints beardPoints)
    makeVertex LineLoop (makePoints earPoints)
    makeVertex LineStrip (makePoints insideEarPoints)  
    makeVertex LineStrip (makePoints' nosePoints)
    makeVertex Polygon (makePoints moustachePoints)  
    makeVertex LineLoop (makePoints mousePoints)
    makeVertex LineStrip (makePoints lipPoints)
    makeVertex LineLoop (makePoints' leftEyePoints)
    makeVertex LineLoop (makePoints' rightEyePoints)
    makeVertex LineStrip (makePoints' rightPupilPoints)
    makeVertex LineStrip (makePoints' leftPupilPoints)
    makeVertex Polygon (makePoints'' leftEyebrowPoints)
    makeVertex Polygon (makePoints'' rightEyebrowPoints)
    makeVertex LineStrip (makePoints teethPoints)
    makeVertex Lines (makePoints teethPoints')
    makeVertex LineStrip (makePoints h)
    makeVertex LineStrip (makePoints a)
    makeVertex LineStrip (makePoints s)
    makeVertex Lines (makePoints k)
    makeVertex LineStrip (makePoints e)
    makeVertex Lines (makePoints ll)
    makeVertex Polygon (makePoints dot)
    makeVertex Lines (makePoints i)
    makeVertex LineStrip (makePoints s')
    makeVertex Lines (makePoints upperF)
    makeVertex LineStrip (makePoints upperU)
    makeVertex LineStrip (makePoints upperN)
    makeVertex Lines (makePoints exclamationMark)    
    makeVertex Polygon (makePoints dot')
    makeVertex Lines (makePoints exclamationMark') 
    makeVertex Polygon (makePoints dot'')   
    flush