import cv2

def click_event(event, x, y, flags, param):
    if event == cv2.EVENT_LBUTTONDOWN:
        # Get the dimensions of the image
        height, width, _ = image.shape

        # Normalize the coordinates to range [-1, 1]
        normalized_x = (2 * x / width) - 1
        normalized_y = 1 - (2 * y / height)

        print(f'({normalized_x:.2f},{normalized_y:.2f},0),')

# Load the image
image = cv2.imread('don.jpg')

# Get the dimensions of the image
height, width, _ = image.shape

# Set the origin at the center
cv2.circle(image, (width // 2, height // 2), 5, (0, 255, 0), -1)

# Display the image with the origin marked
cv2.imshow('Image', image)

# Set the mouse event callback
cv2.setMouseCallback('Image', click_event)

# Wait for a mouse click and close the window
cv2.waitKey(0)
cv2.destroyAllWindows()
